Index: /trunk/gsdl/src/recpt/z3950proto.cpp
===================================================================
--- /trunk/gsdl/src/recpt/z3950proto.cpp	(revision 1346)
+++ /trunk/gsdl/src/recpt/z3950proto.cpp	(revision 1347)
@@ -26,41 +26,123 @@
 #include "z3950proto.h"
 #include "comtypes.h"
-#include <stdio.h>
-
-/*** 
-    We will use the "collection" argument as the name of the database
-    to query on the z3950 server.
-***/
-
-
-z3950_server::z3950_server() {
-  count=0;
-  info=NULL;
-  meta["iconcollection"]="/~johnmcp/gsdl/images/zserver.png";
-}
-
-
-
-
-// z3950 Protocol functions
+#include "browsefilter.h"
+#include "queryfilter.h"
+#include "filter.h"
+// z39.50 yaz stuff
+#include <stdio.h> // for (FILE *) type for yyin and fopen.
+// config file parsing stuff
+#include "z3950cfg.h" // for reading in config files - 
+// defines "struct z3950cfg *zserver_list" as the head of the list.
+extern FILE *yyin;
+extern "C" {
+  extern int zconfigparse();
+}
+
+
+
+
 z3950proto::z3950proto() {
   zserver_count=0;
 }
 
-void z3950proto::add_server (const z3950_server& zserver) {
+z3950proto::~z3950proto() {
+}
+
+void z3950proto::add_server (z3950_server& zserver) {
 
   // append the new server
   zserver_count++;
-  zservers.push_back(zserver);
-}
-
-void z3950proto::configure (const text_t &/*key*/, 
-			    const text_tarray &/*cfgline*/) {
+  zservers.push_back(&zserver);
+}
+
+void z3950proto::read_config_file(const text_t &filename) {
+  struct z3950cfg *here;
+  struct z3950cfg *oldhere;
+  z3950_server *zserver;
+  ShortColInfo_t *tempinfo;
+
+  // zconfigparse() is defined in zparse.tab.c,
+  // which is the bison output of zparse.y
+
+  yyin=fopen(filename.getcstr(),"r");
+  if (yyin==NULL) {
+    cerr << "Could not open "<<filename.getcstr()<<" for reading.\n";
+  }
+  zconfigparse();
+  // we now have the config files in the ptr zserver_list
+  if (zserver_list==NULL)
+    return; // no valid servers found in the config file - note that
+  // the parser will have already spat out any errors.
+
+  // now create z3950servers for each structure in server_list
+  here=zserver_list;
+  while (here!=NULL) {
+    zserver=new z3950_server;
+    tempinfo=new ShortColInfo_t;
+
+    tempinfo->host.setcstr(here->hostname);
+    tempinfo->port=here->port;
+    tempinfo->name.setcstr(here->dbname);
+    zserver->setInfo(tempinfo);
+    zserver->setName(here->shortname);
+    // now collection metadata.
+    zserver->setMeta("collectionname",here->longname);
+    if (here->icon!=NULL)
+      zserver->setMeta("iconcollection",here->icon);
+    if (here->smallicon!=NULL)
+      zserver->setMeta("iconcollectionsmall",here->smallicon);
+    
+    /*    filterclass *filter = new filterclass ();
+	  zserver->add_filter (filter);
+	  browsefilterclass *browsefilter = new browsefilterclass();
+	  zserver->add_filter (browsefilter);
+	  queryfilterclass *queryfilter = new queryfilterclass();
+	  zserver->add_filter (queryfilter);
+    */
+
+    // About list
+    if (here->about!=NULL) {
+      struct z3950aboutlist *about_here=here->about;
+      struct z3950aboutlist *oldabout;
+
+      while (about_here!=NULL) {
+	// problem with default lang (null): can't add ("",..)
+	if (about_here->lang==NULL)
+	  zserver->addcfgAbout("en",about_here->text);
+	else
+	  zserver->addcfgAbout(about_here->lang, about_here->text);
+	oldabout=about_here;
+	about_here=about_here->next;
+	free(oldabout->lang);
+	free(oldabout->text);
+	free(oldabout);
+      }
+    }
+
+    oldhere=here;
+    here=here->next;
+    free(oldhere->shortname);
+    free(oldhere->hostname);
+    free(oldhere->dbname);
+    free(oldhere->longname);
+    free(oldhere->icon);
+    free(oldhere->smallicon);
+    free(oldhere);
+
+    add_server(*zserver);
+  } // end of while loop.
+
+}
+
+void z3950proto::configure (const text_t &key,
+			    const text_tarray &cfgline) {
 
   // this is called for each line in the gsdlsite.cfg file
-  /*  cerr << "z3950proto::configure called:"
-      << "key is " << key.getcstr()
-      << "\n1st line is " << cfgline[0].getcstr() << endl;
-  */
+
+  if (0)
+    cerr << "z3950proto::configure called:"
+	 << "key is " << key.getcstr()
+	 << "\n1st line is " << cfgline[0].getcstr() << endl;
+  
 }
 
@@ -96,5 +178,5 @@
   z3950_server_array::iterator end = zservers.end();
   while (here != end) {
-    collist.push_back(here->getName());
+    collist.push_back((*here)->getName());
     //const ShortColInfo_t *info=here->getInfo();
     //collist.push_back(info->name);
@@ -108,5 +190,5 @@
   z3950_server_array::iterator end = zservers.end();
   while (here != end) {
-    if(here->getName()==collection) {
+    if((*here)->getName()==collection) {
       hascollection=true;
       return;
@@ -133,5 +215,5 @@
   z3950_server_array::iterator end = zservers.end();
   while (here != end) {
-    if(here->getName()==collection) {
+    if((*here)->getName()==collection) {
       break;
     }
@@ -139,6 +221,4 @@
   }
 
-  // is this right? ie does end refer to the last element, or AFTER the
-  // last element?
   if (here==end) {
     err=protocolError;
@@ -149,8 +229,5 @@
   }
 
-  /*  collectinfo.shortInfo.name="sdfg";
-      collectinfo.shortInfo.host="localhost";
-      collectinfo.shortInfo.port=0; */
-  const ShortColInfo_t *colinfo=here->getInfo();
+  const ShortColInfo_t *colinfo=(*here)->getInfo();
   collectinfo.shortInfo.name=colinfo->name;
   collectinfo.shortInfo.host=colinfo->host;
@@ -163,6 +240,7 @@
   // leave ccsCols empty (no cross-coll. searching - for now)
   /*collectinfo.ccsCols=(text_tarray);*/ //not like this!!!
-  collectinfo.languages.push_back("en");
-  collectinfo.languages.push_back("fr");
+  // This info is available from the config file -- johnmcp
+  /*******collectinfo.languages.push_back("en");
+	  collectinfo.languages.push_back("fr");********/
   collectinfo.numDocs=0;
   collectinfo.numWords=0;
@@ -170,18 +248,40 @@
   // copy the text maps over.
   //  collectinfo.collectionmeta; // text_tmap
-  //  delete collectinfo.collectionmeta;
-  collectinfo.collectionmeta=*(here->getMeta());
-  /* collectinfo.format; //text_tmap
-    collectinfo.building; //text_tmap
+  collectinfo.collectionmeta=*((*here)->getMeta());
+  collectinfo.format=*((*here)->getFormat()); //text_tmap
+  /*    collectinfo.building; //text_tmap  */
+
+  ////collectinfo.receptionist="z3950"; 
+  /* for now... this is a url,  relative to .../cgi-bin.
+     NOTE: if this is empty, it defaults to _gwcgi_?a=p&p=about&c=<colname>
   */
-
-collectinfo.receptionist="z3950"; /* for now... this is a url,
-				    relative to .../cgi-bin   */
 }
 
 void z3950proto::get_filterinfo (const text_t &/*collection*/,
-				 InfoFiltersResponse_t &/*response*/,
+				 InfoFiltersResponse_t &response,
 				 comerror_t &/*err*/, ostream &/*logout*/) {
-
+  // we'll fake it here, and say we have set up some filters
+  response.filterNames.insert("BrowseFilter");
+  response.filterNames.insert("QueryFilter");
+  response.filterNames.insert("NullFilter");
+
+}
+
+void z3950proto::get_filteroptions (const text_t &/*collection*/,
+				    const InfoFilterOptionsRequest_t &/*req*/,
+				    InfoFilterOptionsResponse_t &response, 
+				    comerror_t &err, ostream &/*logout*/) {
+  // for now, assume all servers have the same characteristics
+  /*  if (request.filterName=="QueryFilter") { } 
+      else if (request.filterName=="BrowseFilter") { } 
+      else if (request.filterName=="NullFilter") {  } */
+  response.filterOptions["Index"].type=FilterOption_t::stringt;
+  response.filterOptions["Index"].repeatable=FilterOption_t::onePerQuery;
+  response.filterOptions["Index"].defaultValue="any";
+  response.filterOptions["Index"].validValues.push_back(".any");
+  response.filterOptions["Index"].validValues.push_back(".title");
+  response.filterOptions["Index"].validValues.push_back(".author");
+  // and maybe ["Language"] option as well?
+  err=noError;
 }
 
@@ -190,58 +290,287 @@
 			 FilterResponse_t &response,
 			 comerror_t &err, ostream &logout) {
-  // assume this function is only called when creating the title page,
-  // and looking for the metadata regarding icons.
-  response.numDocs=0;
-  response.isApprox=Approximate; // Exact | Approximate | MoreThan
+  // this function is called when:
+  //  *  creating the title page,(looking for iconcoll* & collectname metadata)
+  //  *  creating the about page (looking for "Title" metadata)
+  //  * doing the query - (note that a request for metadata comes first, then
+  // filterOptions = FRmetadata | FROID | FRtermFreq (64+4+1)
+
+  // metadata-only requests have filterName="NullFilter", else "QueryFilter".
+  // For the title page, we should not create a connection to the target
+  // (target means the actual z39.50 server, origin means us), but
+  // for the about page and query pages, we need to get information from the
+  // origin. (eg for the about page, we will print out some info such as ID,
+  // name and version.
+
+  // cerr now goes to errout.txt in etc directory
+  err=noError;
+
+  // get relevant "collection"
+  z3950_server_array::iterator zserver = zservers.begin();
+  z3950_server_array::iterator zend = zservers.end();
+  while (zserver != zend) {
+    if((*zserver)->getName()==collection) {
+      break;
+    }
+    zserver++;
+  }
+  // now have collection in zserver.
+  
+  ColInfoResponse_t info;
+  ResultDocInfo_t *docInfo;
+  
   // leave response.termInfo empty
-  // leave response.docInfo empty
-  /* got the following for first query:
-     request.filterResultOptions=FRmetadata;
-     request.getParents=getParents
-     request.fields=metadata
-     request.docSet (includes OID);
+  // response.termInfo.push_back(""); ??????? (should be empty if not req.)
+
+  // See if this is for a query action
+  if (request.filterName=="QueryFilter") {
+    /* Sample OptionValue pairs
+      `StartResults'=`1'
+      `EndResults'=`20'
+      `Term'=`firstword secondword' (term is just whatever the user typed in)
+      `QueryType'=`ranked' => 'OR' (cgiarg t=1)
+      `QueryType' = `boolean' => 'AND' (cgiarg t=0)
+      `Casefold'=`true'
+      `Stem'=`false'
+      `Maxdocs'=`50'
+     */
+    // go through options
+    text_t opt_term;            // the term(s) that the user entered 
+    text_t opt_fields;          // which fields to search on
+    int opt_start=1, opt_end=20; // default values
+    int nummatches=0, maxdocs=50; // default values
+    OptionValue_tarray::iterator ov_here=request.filterOptions.begin();
+    OptionValue_tarray::iterator ov_end=request.filterOptions.end();
+    while (ov_here != ov_end) {
+      //      cout << "OV pair: `" << ov_here->name.getcstr() << "'=`" 
+      //   << ov_here->value.getcstr() << "'\n";
+      if (ov_here->name=="Term") 
+	{
+	  opt_term=ov_here->value;
+	} else if (ov_here->name=="Index") 
+	  {
+	    opt_fields=ov_here->value;
+	  } else if (ov_here->name=="StartResults") 
+	    {
+	      opt_start=ov_here->value.getint();
+	    } else if (ov_here->name=="EndResults") 
+	      {
+		opt_end=ov_here->value.getint();
+	      } else if (ov_here->name=="Maxdocs") 
+		{
+		  maxdocs=ov_here->value.getint();
+		} 
+      ov_here++;
+    }
+    err=noError;
+    text_tarray *titles=(*zserver)->getrecordTitles(opt_term,
+						    opt_fields,
+						    opt_start, // first to get
+						    opt_end-opt_start, //count
+						    &nummatches,err);
+    if (err!=noError) {
+      // can we return an err msg in a response, or just use
+      // the more drastic Greenstone error mechanism?
+      docInfo=new ResultDocInfo_t;
+      response.docInfo.push_back(*docInfo);
+      docInfo->metadata["Title"].values.push_back("Error - query err?");
+      logout << "\nz3950 filter query: error connecting to server\n";
+      // for now, DON'T use GSDL protocol err.
+      err=noError;
+      return;
+    }
+    // check if (titles==NULL) - only happens on error?
+    if (nummatches>0) {
+      text_tarray::iterator titles_here=titles->begin();
+      text_tarray::iterator titles_end=titles->end();
+      int counter=1;
+      while (titles_here!=titles_end) {
+	docInfo=new ResultDocInfo_t; 
+	docInfo->metadata["Title"].values.push_back(*titles_here);
+	docInfo->result_num=counter;
+	// we need to give some OID, so we'll just use counter for now...
+	// make it the number into the whole possible retrieved set.
+	docInfo->OID=counter+opt_start-1;
+	response.docInfo.push_back(*docInfo);
+	counter++;
+	titles_here++;
+      }
+    }
+
+    if (request.filterResultOptions & FRtermFreq) {
+      if (nummatches>maxdocs) {
+      	response.numDocs=maxdocs; // eg "more than 50" (if Maxdocs==50)
+	response.isApprox=MoreThan;
+      } else {
+	response.numDocs=nummatches; // eg "36 documents"
+	response.isApprox=Exact; // Exact | Approximate | MoreThan
+      }
+    } // end of if (... & FRtermFreq)
+    
+  } // end of if (... & FROID)
+  else {
+    // this wasn't a query action
+
+    if (request.filterOptions.size()>0 &&
+	request.filterOptions[0].name=="ParentNode") {
+      // don't want to return anything
+      return;
+      /*    } else if (request.docSet.size() &&
+	    request.docSet[0]!="collection") {
+	    // documentaction
+	    // if docSet is not empty, it is either "collection", or an array
+	    // of OIDs 
+	    docInfo=new ResultDocInfo_t;
+	    response.docInfo.push_back(*docInfo);
+      */
+    } else {
+      // in case we need to return only metadata
+      docInfo=new ResultDocInfo_t;
+      response.docInfo.push_back(*docInfo); 
+    }
+  }
+
+  // Fill in metadata for each response.docInfo (if wanted)
+  if (request.filterResultOptions & FRmetadata) {
+    get_collectinfo (collection, info, err, logout);
+    // should check err returned here....
+
+    // get the Query out of the filterOptions.
+    text_t query="";
+    text_t field="";
+    OptionValue_tarray::iterator opt_here=request.filterOptions.begin();
+    OptionValue_tarray::iterator opt_end=request.filterOptions.end();
+    while (opt_here!=opt_end) {
+      if (opt_here->name=="Query") {
+	query=opt_here->value;
+	if (field!="") break; // break from loop if we've got both
+      } else if (opt_here->name=="Index") {
+	field=opt_here->value;
+	if (query!="") break; // break from loop if we've got both
+      }
+      opt_here++;
+    }
+
+    if (!request.fields.empty()) {
+      // loop on each document being returned
+      ResultDocInfo_tarray::iterator docs_here=response.docInfo.begin();
+      ResultDocInfo_tarray::iterator docs_end=response.docInfo.end();
+      while (docs_here!=docs_end) {
+	
+	// loop on all the metadata fields in request.fields (type text_tset)
+	text_tset::iterator fields_here=request.fields.begin();
+	text_tset::iterator fields_end=request.fields.end();
+	text_tmap::iterator it;
+	while (fields_here!=fields_end) {
+	  it=info.collectionmeta.find(*fields_here);
+	  ////////// cerr << "filter: getting " << (*fields_here).getcstr();
+	  if (it!=info.collectionmeta.end())
+	    docs_here->metadata[*fields_here].values.push_back((*it).second);
+	  else if (*fields_here=="Title" && !request.docSet.empty()) { 
+	    // We only do this for a document action.
+	    // (This comes through as a NullQuery).
+	    // hopefully docSet is only not empty for documentaction...
+	    text_t doctitle;
+	    int i;
+	    // check that docSet isn't empty first!!!!!!
+	    i=request.docSet[0].getint();
+	    text_t doctext="unneeded";
+	    (*zserver)->getfullrecord(query, field, i, doctitle, doctext, err);
+	    // check err value!
+	    docs_here->metadata["Title"].values.push_back(doctitle);	    
+	  } else {
+	    docs_here->metadata[*fields_here].values.push_back("");
+	    /////// cerr << " (not found)";
+	  }
+	  ////////cerr << "\n";
+	  fields_here++;
+	} // end of inner while loop
+	docs_here++;
+      } // end of outer while loop
+    } // end of if (!request.fields.empty())
+
+    else { // request.fields empty: return all metadata for about page or query
+      // we'll only put it in the first docInfo.
+      text_tmap::iterator colmeta_here=info.collectionmeta.begin();
+      text_tmap::iterator colmeta_end=info.collectionmeta.end();
+      while (colmeta_here!=colmeta_end) {
+	response.docInfo[0].metadata[(*colmeta_here).first].
+	  values.push_back((*colmeta_here).second);
+	/////cerr << "\t" << (*colmeta_here).first.getcstr() << "\n";
+	colmeta_here++;
+      }
+
+      // check if "collectionextra" metadata is set. If it isn't, we should
+      // create connection to target to get it.
+      if (info.collectionmeta.find("collectionextra")==colmeta_end) {
+	// it hasn't been set yet...
+	text_t abouttext="<B>Server Online</B><br>\n";
+	abouttext+=(*zserver)->getzAbout();
+	// add in the "About" text we read in from config file.
+	// how do we incorporate multi-lingual metadata?
+	abouttext+="<P>\n";
+	text_t tmpabout;
+
+	if ((*zserver)->getcfgAbout("en", tmpabout)==true)
+	  abouttext+=tmpabout;
+
+	(*zserver)->setMeta("collectionextra",abouttext);
+	response.docInfo[0].metadata["collectionextra"].values.push_back(abouttext);
+      }
+    } // end of else
+
+    // do indices' names, regardless of whether asked for or not...
+    if (!response.docInfo.empty()) {
+     response.docInfo[0].metadata[".author"].values.push_back("author fields");
+      response.docInfo[0].metadata[".title"].values.push_back("title fields");
+      response.docInfo[0].metadata[".any"].values.push_back("any fields");
+    }
+  } //end of  if (... & FRmetadata) ...
+}
+
+
+
+void z3950proto::get_document (const text_t &collection,
+			       const DocumentRequest_t &request,
+			       DocumentResponse_t &response,
+			       comerror_t &err, ostream &logout) {
+
+  err=noError;
+
+  // get relevant "collection"
+  z3950_server_array::iterator zserver = zservers.begin();
+  z3950_server_array::iterator zend = zservers.end();
+  while (zserver != zend) {
+    if((*zserver)->getName()==collection) {
+      break;
+    }
+    zserver++;
+  }
+  // now have collection in zserver.
+
+  /*  cout << "get document:\n\tOID: " << request.OID.getcstr()
+      << "\n\tdocType: " << request.docType.getcstr()
+      << "\n\tdocFormat: " << request.docFormat.getcstr() <<"\n";
   */
-  // fill in the metadata for each of the OIDs (if it is requested)
-  if (request.filterResultOptions & FRmetadata) {
-    // request.fields // type text_tset
-    // docInfo is type ResultDocInfo_tarray
-    ColInfoResponse_t *info = new ColInfoResponse_t;
-    get_collectinfo (collection, *info, err, logout);
-    // should check err returned here....
-
-    ResultDocInfo_t *docInfo=new ResultDocInfo_t;
-    
-    text_tmap::iterator it=info->collectionmeta.find("collectionname");
-    // cerr now goes to errout.txt in etc directory
-    // "(*it).first" is key, "(*it).second" is value(s).
-    if (it!=info->collectionmeta.end()) 
-      docInfo->metadata["collectionname"].values.push_back((*it).second);
-    else // needs to exist, but be empty
-      docInfo->metadata["collectionname"].values.push_back("");
-
-    it=info->collectionmeta.find("iconcollection");
-    if (it!=info->collectionmeta.end()) 
-      docInfo->metadata["iconcollection"].values.push_back((*it).second);
-    else // needs to exist, but be empty
-      docInfo->metadata["iconcollection"].values.push_back("");
-
-    it=info->collectionmeta.find("iconcollectionsmall");
-    if (it!=info->collectionmeta.end()) 
-      docInfo->metadata["iconcollectionsmall"].values.push_back((*it).second);
-    else // needs to exist, but be empty
-      docInfo->metadata["iconcollectionsmall"].values.push_back("");
-    
-
-    response.docInfo.push_back(*docInfo);
-  }
-
-  err=noError;
-}
-
-void z3950proto::get_document (const text_t &/*collection*/,
-			       const DocumentRequest_t &/*request*/,
-			       DocumentResponse_t &/*response*/,
-			       comerror_t &err, ostream &logout) {
-
+
+  /* docresponse consists of
+     text_t response.doc */
+  text_t title="unneeded";
+  text_t doctext;
+  text_t query; // this should not be needed, as we have already connected to 
+  // get the  title....
+  text_t field; // ditto...
+  (*zserver)->getfullrecord(query,field,request.OID.getint(),
+			    title,doctext,err);
+  // check return value of above? (false=>not connected) 
+  if (err==noError)
+    response.doc=doctext;
+  else {
+    // could print out different messages based on error type....
+    response.doc="<h2>Error</h2>There was an error while connecting to the ";
+    response.doc+="z39.50 server (ie target). Most likely this was a \n";
+    response.doc+="\"Connection Refused\" error.\n";
+
+  }
   if (0) {
     err=protocolError;
@@ -249,5 +578,2 @@
   }
 }
-
-
-#endif
Index: /trunk/gsdl/src/recpt/z3950proto.h
===================================================================
--- /trunk/gsdl/src/recpt/z3950proto.h	(revision 1346)
+++ /trunk/gsdl/src/recpt/z3950proto.h	(revision 1347)
@@ -28,62 +28,5 @@
 
 #include "recptproto.h"
-
-// each server can have one or more databases
-/*
-  class z3950_DB {
-  protected:
-  text_t name; // Descriptive name
-  text_t database; // name for server
-  
-  public:
-  z3950_DB();     // constructor
-  ~z3950_DB();    // deconstructor
-  const text_t getName() {return name;}                // this gets name
-  void setName(text_t newName) {name=newName;} // this sets name
-  // need to get next (for linked list)
-  };
-  
-
-  typedef  vector<z3950_DB>  z3950_DB_array;
-*/
-
-/*class z3950_DB_Array {
-  protected:
-  int count;
-  // some arraytype...
-  public:
-  z3950_DB first();
-  z3950_DB last();
-  void     add(z3950_DB *db);
-  void     remove(z3950_DB *db);
-  };
-*/
-
-
-class z3950_server {
- protected:
-  text_t title;    // Descriptive name
-  text_t hostname; // network name (IP or host+domain name)
-  text_tmap meta;  // metadata for this collection (ie server/database pair)
-  // this is currently only iconcollection (and iconcollectionsmall)
-  int count;
-  //  z3950_DB_array* db;
-  ShortColInfo_t *info; // has  (database) name, host and port
-
- public:
-  z3950_server();
-  // z3950_DB_array getDBs();
-  const text_t getName() {return title;}
-  void setName(const text_t &newname) {title=newname;}
-  //  void setHostname(const text_t &newname) {hostname=newname;}
-  void setInfo(ShortColInfo_t *newinfo) {info=newinfo;}
-  const ShortColInfo_t *getInfo() {return info;}
-  const text_tmap *getMeta() {return &meta;}
-};
-
-typedef  vector<z3950_server>  z3950_server_array;
-
-
-
+#include "z3950server.h"
 
 class z3950proto : public recptproto {
@@ -93,12 +36,15 @@
 public:
   z3950proto();
-  virtual ~z3950proto() {}
+  virtual ~z3950proto();
 
+  int getServerCount() { return zserver_count;}
   /*
   void add_collectserver (collectserver *thecserver) 
         {cservers.addcollectserver(thecserver);}
   */
+  
+  void add_server(z3950_server& zserver);
 
-  void add_server(const z3950_server& zserver);
+  void read_config_file(const text_t &filename);
 
   void configure (const text_t &key, const text_tarray &cfgline);
@@ -128,4 +74,9 @@
       FilterResponse_t &response, ostream &logout);
   */
+
+  void get_filteroptions (const text_t &collection,
+                          const InfoFilterOptionsRequest_t &request,
+                          InfoFilterOptionsResponse_t &response, 
+                          comerror_t &err, ostream &logout);
   
   void filter (const text_t &collection,
@@ -141,4 +92,3 @@
 };
 
-
 #endif
Index: /trunk/gsdl/src/recpt/z3950server.cpp
===================================================================
--- /trunk/gsdl/src/recpt/z3950server.cpp	(revision 1347)
+++ /trunk/gsdl/src/recpt/z3950server.cpp	(revision 1347)
@@ -0,0 +1,271 @@
+#include "z3950server.h"
+#include "comtypes.h"
+#include <stdio.h>
+// z39.50 yaz stuff
+
+extern "C" {
+#include "yaz/client/yaz_zclient.h"
+}
+
+/*** 
+     each z39.50 server+database pair is a GSDL collection.
+***/
+
+z3950_server::z3950_server() {
+  info=NULL;
+  connected=false;
+  titles=NULL;
+  // for now, assume that all records will have text associated with them.
+  meta["hastxt"]="1";
+  // for now, assume we don't want ANY DocumentButtons.
+  format["DocumentButtons"]="";
+}
+
+z3950_server::~z3950_server() {
+}
+
+void z3950_server::setMeta(const text_t &key, const text_t &value) {
+  meta[key]=value;
+}
+
+void z3950_server::setName(const text_t &newname) {
+  title=newname;
+  meta["collectionname"]=newname;
+}
+
+void z3950_server::addcfgAbout(const text_t &lang, const text_t &abouttext) {
+    about[lang]=abouttext;
+}
+
+bool z3950_server::getcfgAbout(const text_t &lang, text_t &abouttxt) {
+  text_tmap::iterator it;
+  it=about.find(lang);
+  if (it==about.end()) return (false);
+  abouttxt=((*it).second);
+  return (true);
+}
+
+
+// now functions that actually talk over the tcp connection.
+
+// create a tcp connection to the associated target. Currently, this will
+// re-initialise if we are already connected.
+bool z3950_server::connect() {
+  text_t server_and_port;
+  char *zserverinfo;
+
+  server_and_port=info->host+":"+info->port;
+  // remember that info.name is the database name
+
+  z_initialize();
+
+  if (z_cmd_open(server_and_port.getcstr(),info->name.getcstr())==1)
+    // we got a connection error
+    return false;
+
+  // get initialisation response.
+  z_getnextAPDU();
+  zserverinfo=z_get_initResponse();
+  if (zserverinfo!=NULL) {
+    z_initstr.appendcstr(zserverinfo);
+  }
+  free(zserverinfo);
+
+  connected=true;
+  return true;
+}
+
+void z3950_server::parseQuery(const text_t &query, 
+			      const text_t &fields,
+			      text_t &parsed_query) {
+  /****** FIXME *****/
+  // We need to format the query string into RPN - 
+  // by just passing it like this, it will only work for simple queries.
+  // This will require us to actually come up with a query syntax and 
+  // a parser. For now, we'll just do an "AND" query for all terms
+
+  // we need to count number of terms separated by a space
+  char *ptr=query.getcstr();
+  int strlength=strlen(ptr);
+  bool inword=false;
+  int num_terms=0;
+  for (int i=0;i<strlength;i++) {
+    if (*(ptr+i)!=' ') {
+      if (inword==false) {
+	inword=true;
+	num_terms++;
+      }
+    }
+    else { // ptr+i is a space
+      inword=false;
+      }
+  }
+  
+  // set the field(s) to search on - main ones (that I've found) include:
+  //  1016  => Any
+  //  1     => (Personal) Name
+  //  4     => Title
+  //  21    => Subject Heading
+  //  45    => Subject precis
+  // Note I have no idea how these actually work - I think some servers
+  // only have limited fields, and map all subject-type requests into that
+  // subject field, etc.
+
+  parsed_query="@attr 1=";
+  if (fields==".author")
+    parsed_query+="1 ";
+  else if (fields==".title")
+    parsed_query+="4 ";
+  else // fields==".any"
+    parsed_query+="1016 ";
+
+  // append "@and" for each term after the first
+  for (int i=1;i<num_terms;i++)
+    parsed_query+="@and ";
+  // append the actual query
+  parsed_query+=query;
+
+}
+
+text_tarray *z3950_server::getrecordTitles(const text_t &query, 
+					   const text_t &fields,
+					   int first, int count,
+					   int *nummatches, comerror_t &err) {
+  char **c_str_titles;
+  int i;
+  int last;
+  if (titles!=NULL) delete (titles);
+  titles=new text_tarray;
+
+  /* check if connected */
+  if (connected==false) 
+    if (connect()==false) {
+      // we could not connect.
+      err=protocolError;
+      return (NULL);
+    }
+  
+
+  text_t expanded_query="";
+  parseQuery(query,fields,expanded_query);
+
+  // following functions defined in yaz_zclient.c
+  *nummatches=z_cmd_dosearch(expanded_query.getcstr()); // returns # found, -1 on err.
+  if (*nummatches<=0) {
+    if (*nummatches==0) {
+      // no matches
+      return (NULL);
+    } else  if (*nummatches==-1) {
+      // prefix query error
+      err=protocolError;
+      return (NULL);
+    }  else if (*nummatches==-2) {
+      // sendsearchRequest not answered by searchResponse
+      err=protocolError;
+      return (NULL);
+    }
+  }
+  // could do a sort eventually, eg on date, title, etc.
+  // (non-existent function)    z_sort(field, asc|desc);
+  /* min of (count, first + (*nummatches) ) */
+  // z_getrecordTitles ( first, howmany )
+  c_str_titles=z_getrecordTitles(first,min(count,*nummatches-first+1));
+  if (c_str_titles==NULL) {
+    // an error occurred. we need a logout/err as an arg
+    return (NULL);
+  }
+  if (c_str_titles[0]==0) {
+    // no matches.
+    return (NULL);
+  }
+  last=(int)c_str_titles[0];
+  for (i=1;i<=last;i++) {
+    titles->push_back(c_str_titles[i]);
+    free(c_str_titles[i]);
+  }
+  free(c_str_titles);
+  return (titles);
+  
+}
+
+bool z3950_server::getfullrecord(const text_t &query, const text_t &fields,
+				 const int ID, 
+				 text_t &rettitle, 
+				 text_t &rettext, comerror_t &err) {
+  if (connected==false) {
+    if (connect()==false) {
+      // error connecting...
+      err=protocolError;
+      return (false);
+    }
+    // since we have just re-connected, we need to do the
+    // query again.
+
+    text_t expanded_query="";
+    parseQuery(query,fields,expanded_query);
+
+    int returned=z_cmd_dosearch(expanded_query.getcstr());
+    if (returned<=0) {
+      // 0 => none.
+      // <0 => error
+      err=protocolError;
+      return (false);
+    }
+  }
+
+  if (rettitle!="unneeded") {
+    char **c_str_titles;
+    //int dummy;
+    c_str_titles=z_getrecordTitles(ID,1); // check this return value.
+    if (c_str_titles!=NULL && (int)c_str_titles[0]==1) {
+      rettitle.setcstr(c_str_titles[1]); // and check this 
+      free (c_str_titles);
+      // rettitle="Dummy Title";
+    } else {
+      // we didn't get something....
+      rettitle="Nothing Returned...";
+    }
+  }
+
+  if (rettext!="unneeded") {
+    // get the text
+    rettext.setcstr(z_getfullRecord(ID));
+  }
+  return (true);
+  }
+
+text_t &z3950_server::getzAbout() {
+  text_t zserverresp;
+
+  // Assume we have not yet connected, so that must be done here.
+  if (connected==true)
+    return (z_initstr);
+  
+  // we need to create the tcp connection to the target (server)  
+  //  z_initstr=new text_t;
+  
+  if (connect()==false) {
+    z_initstr.setcstr("<H2>Server offline</H2>Error - could not connect to server <B>");
+    z_initstr += info->host.getcstr();
+    z_initstr += "</B> on port ";
+    z_initstr += info->port;
+    z_initstr += "\n";
+    return (z_initstr);
+  }
+  
+  // z_initstr currently contains the target's response. We want to
+  // PREPEND the following information.
+  zserverresp=z_initstr;
+  z_initstr="Internet server: <b>";
+  z_initstr+=info->host;
+  z_initstr+="</b> on port ";
+  z_initstr+=info->port;
+  z_initstr+=".<br>\n";
+  z_initstr+=zserverresp;
+
+  // should close /******* WHAT IF DOING A QUERY!??!?!? ********/
+  // z_cmd_close(0);
+  // connected=false;
+  return (z_initstr);
+}
+
